export default class SIGNAL_MANAGER {
	constructor() {
		this.signals = {};
	}

	subscribe(signal, callback) {

		let self = this;

		if(!self.signals.hasOwnProperty(signal)) {
			self.signals[signal] = [];
		}

		return self.signals[signal].push(callback);
	}
	
	emit(signal, data = {}) {

		let self = this;

		if(!self.signals.hasOwnProperty(signal)) {
		 	return [];
		}
				
		return self.signals[signal].map(callback => callback(data));
	}
}